import React from 'react';
import ReactDOM from 'react-dom';
import { arc } from 'd3';

const width = 960;
const height = 500;
const hairH = 100;
const centerX = width / 2;
const centerY = (height + hairH) / 2;
const radiusY = (height - hairH) / 2;
const strokeWidth = 13;
const eyeOffsetX = 125;
const eyeOffsetY = 50;
const eyebrowYOffset = -70;
const eyeRadius = 35;
const mouthWidth = 10;
const mouthRadius = 45;

//creation of mouth
const mouthArc = arc()
  .innerRadius(-mouthRadius)
  .outerRadius(mouthRadius + mouthWidth)
  .startAngle(Math.PI / 2)
  .endAngle((Math.PI * 3) / 2);

//creation of eye arc
const eyeArc = d3
  .arc()
  .innerRadius(26)
  .outerRadius(40)
  .startAngle(-Math.PI / 3)
  .endAngle(Math.PI / 3);

//creation of ear arc
const earArc = d3
  .arc()
  .innerRadius(0)
  .outerRadius(80)
  .startAngle(-Math.PI / 2)
  .endAngle(Math.PI / 2);

const App = () => (
  <svg width={width} height={height}>
    <g transform={`translate(${centerX},${centerY})`}>
      <circle
        r={radiusY - strokeWidth / 3}
        fill="yellow"
        stroke="black"
        stroke-width={strokeWidth}
      />
      <circle
        cx={-eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius}
        fill="white" //fill the eye color
        stroke="black" //border color of eye
        stroke-width="8" //border width of eye
      />
      <circle
        cx={eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius}
        fill="white" //fill the eye color
        stroke="black" //border color of eye
        stroke-width="8" //border width of eye
      />
      <circle
        cx={eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius / 3}
        fill="black" //fill the eye ball color
        stroke="white" //border color of eye ball
      />
      <circle
        cx={-eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius / 3}
        fill="black" //fill the eye ball color
        stroke="white" //border color of eye ball
      />
      <ellipse
        rx={eyeRadius}
        ry={eyeRadius / 2}
        fill="orange" //file the ellipse color
        stroke="black" //borrder color of ellipse
        transform="rotate(-90  )"
      />
      <line
        x1={100}
        y1={33}
        x2={30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <line
        x1={-100}
        y1={33}
        x2={-30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <line
        x1={-100}
        y1={20}
        x2={-30}
        y2={10}
        stroke="green" //line color
        stroke-width="2" // line width
      />
      <line
        x1={100}
        y1={20}
        x2={30}
        y2={10}
        stroke="green" //line color
        stroke-width="2" // line width
      />
      <line
        x1={100}
        y1={10}
        x2={30}
        y2={10}
        stroke="red" //line color
        stroke-width="2" // line width
      />
      <line
        x1={-100}
        y1={10}
        x2={-30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <path
        d={eyeArc()}
        transform="rotate(5)    translate(-132,-68)"
        fill="black"
      />
      <path
        d={eyeArc()}
        transform="rotate(-5)    translate(132,-68)"
        fill="black"
      />
      <path
        d={earArc()}
        transform="rotate(70) translate(10,-195)"
        fill="black"
      />
      <path
        d={earArc()}
        transform="rotate(-70) translate(10,-195)"
        fill="black"
      />
      <path
        d={mouthArc()}
        transform="translate(-6,60)"
        fill="red"
      />
      <path
        d="M 0 -190 l 0 -100 m -25 95 l -40 -80 m 130 0 l -40 85"
        stroke="black"
        stroke-width={strokeWidth / 2}
      />
    </g>
  </svg>
);

//creation of mouth
const mouthArc = arc()
  .innerRadius(-mouthRadius)
  .outerRadius(mouthRadius + mouthWidth)
  .startAngle(Math.PI / 2)
  .endAngle((Math.PI * 3) / 2);

//creation of eye arc
const eyeArc = d3
  .arc()
  .innerRadius(26)
  .outerRadius(40)
  .startAngle(-Math.PI / 3)
  .endAngle(Math.PI / 3);

//creation of ear arc
const earArc = d3
  .arc()
  .innerRadius(0)
  .outerRadius(80)
  .startAngle(-Math.PI / 2)
  .endAngle(Math.PI / 2);

const App = () => (
  <svg width={width} height={height}>
    <g transform={`translate(${centerX},${centerY})`}>
      <circle
        r={radiusY - strokeWidth / 3}
        fill="yellow"
        stroke="black"
        stroke-width={strokeWidth}
      />
      <circle
        cx={-eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius}
        fill="white" //fill the eye color
        stroke="black" //border color of eye
        stroke-width="8" //border width of eye
      />
      <circle
        cx={eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius}
        fill="white" //fill the eye color
        stroke="black" //border color of eye
        stroke-width="8" //border width of eye
      />
      <circle
        cx={eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius / 3}
        fill="black" //fill the eye ball color
        stroke="white" //border color of eye ball
      />
      <circle
        cx={-eyeOffsetX}
        cy={-eyeOffsetY}
        r={eyeRadius / 3}
        fill="black" //fill the eye ball color
        stroke="white" //border color of eye ball
      />
      <ellipse
        rx={eyeRadius}
        ry={eyeRadius / 2}
        fill="orange" //file the ellipse color
        stroke="black" //borrder color of ellipse
        transform="rotate(-90  )"
      />
      <line
        x1={100}
        y1={33}
        x2={30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <line
        x1={-100}
        y1={33}
        x2={-30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <line
        x1={-100}
        y1={20}
        x2={-30}
        y2={10}
        stroke="green" //line color
        stroke-width="2" // line width
      />
      <line
        x1={100}
        y1={20}
        x2={30}
        y2={10}
        stroke="green" //line color
        stroke-width="2" // line width
      />
      <line
        x1={100}
        y1={10}
        x2={30}
        y2={10}
        stroke="red" //line color
        stroke-width="2" // line width
      />
      <line
        x1={-100}
        y1={10}
        x2={-30}
        y2={10}
        stroke="red"
        stroke-width="2"
      />
      <path
        d={eyeArc()}
        transform="rotate(5)    translate(-132,-68)"
        fill="black"
      />
      <path
        d={eyeArc()}
        transform="rotate(-5)    translate(132,-68)"
        fill="black"
      />
      <path
        d={earArc()}
        transform="rotate(70) translate(10,-195)"
        fill="black"
      />
      <path
        d={earArc()}
        transform="rotate(-70) translate(10,-195)"
        fill="black"
      />
      <path
        d={mouthArc()}
        transform="translate(-6,60)"
        fill="red"
      />
      <path
        d="M 0 -190 l 0 -100 m -25 95 l -40 -80 m 130 0 l -40 85"
        stroke="black"
        stroke-width={strokeWidth / 2}
      />
    </g>
  </svg>
);

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);
